XYZZY(hdu1317,传递闭包+Dijstra)

http://acm.hdu.edu.cn/showproblem.php?pid=1317

http://acm.hust.edu.cn/vjudge/contest/view.action?cid=29015#problem/F

F - XYZZY

Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u

Submit

 

Status

 

Practice

 

HDU 1317

Description

It has recently been discovered how to run open-source software on the Y-Crate gaming device. A number of enterprising designers have developed Advent-style games for deployment on the Y-Crate. Your job is to test a number of these designs to see which are winnable. 

Each game consists of a set of up to 100 rooms. One of the rooms is the start and one of the rooms is the finish. Each room has an energy value between -100 and +100. One-way doorways interconnect pairs of rooms. 

The player begins in the start room with 100 energy points. She may pass through any doorway that connects the room she is in to another room, thus entering the other room. The energy value of this room is added to the player's energy. This process continues until she wins by entering the finish room or dies by running out of energy (or quits in frustration). During her adventure the player may enter the same room several times, receiving its energy each time. 

 

Input

The input consists of several test cases. Each test case begins with n, the number of rooms. The rooms are numbered from 1 (the start room) to n (the finish room). Input for the n rooms follows. The input for each room consists of one or more lines containing: 

the energy value for room i 

the number of doorways leaving room i 

a list of the rooms that are reachable by the doorways leaving room i 

The start and finish rooms will always have enery level 0. A line containing -1 follows the last test case. 

 

Output

In one line for each case, output "winnable" if it is possible for the player to win, otherwise output "hopeless". 

 

Sample Input

5

0 1 2

-60 1 3

-60 1 4

20 1 5

0 0

5

0 1 2

20 1 3

-60 1 4

-60 1 5

0 0

5

0 1 2

21 1 3

-60 1 4

-60 1 5

0 0

5

0 1 2

20 2 1 3

-60 1 4

-60 1 5

0 0

-1

 

Sample Output

hopeless

hopeless

winnable

winnable

解析:

题意:大意是一个人最初拥有能量值100,问他是否可以顺利从起点1走到终点n。每个房间都有能量值(有正有负),每进入一个房间都会得到相应的能量值,允许重复走,但从始至终要保证那人拥有整个能量,否则失败

思路:floyd传递闭包+Bellman_ford

注意:边无权值,权值在点上

1.利用floyd传递闭包

2.因为存在负权,所以用Bellman_ford求最短路

3.判断是否存在正环或者到达终点的最短路径为正

 328 KB 93 ms C++ 1209 B

 */

#include<stdio.h>
#include<string.h>
#include <iostream>
using namespace std;
const int maxn=100+10;
const int inf=1000000001;
int map[maxn][maxn],d[maxn],val[maxn];
int u[maxn*maxn],v[maxn*maxn];
int n,m;
void floyd()
{
  for(int k=1;k<=n;k++)
   for(int i=1;i<=n;i++)
    for(int j=1;j<=n;j++)
     map[i][j]=map[i][j]||(map[i][k]&&map[k][j]);//求闭包
}
void Bellman_ford()//求最短路径
{
for(int i=1;i<=n;i++)
d[i]=-inf;
d[1]=100;
for(int k=1;k<n;k++)
 for(int i=0;i<m;i++)
 {
 	int x=u[i];
 	int y=v[i];
 	if(d[y]<d[x]+val[y]&&d[x]+val[y]>0)
 	d[y]=d[x]+val[y];
 }
}
int solve()
{
for(int i=0;i<m;i++)
{
int x=u[i];
 	int y=v[i];
 	if(d[y]<d[x]+val[y]&&d[x]+val[y]>0)
       if(map[y][n])//如果存在正环
       return 1;
}
if(d[n]>0)//最后路径为正
return 1;
else
return 0;
}
int main()
{
int i,j;
while(scanf("%d",&n)!=EOF)
{
  if(n==-1)
  break;
  memset(val,0,sizeof(val));
 memset(map,0,sizeof(map));
  for(i=1;i<=n;i++)
  map[i][i]=1;
int k,x;
m=0;
for(i=1;i<=n;i++)
{
scanf("%d%d",&val[i],&k);
while(k--)
{scanf("%d",&x);
u[m]=i;
v[m++]=x;
map[i][x]=1;
}
}
floyd();
Bellman_ford();
int ok=solve();
if(ok)
printf("winnable\n");
else
printf("hopeless\n");
}
return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值